# Seed project for nodejs projects using express and typescript

# Pre-installed features -

- `Jest` for unit tests as well as test coverage
- `JWT` for authentication
- `express-validator` for API request validation
- `Winston` logger for robust logging
- `nconf` for env loading/management
- `eslint` for linting errors
- `Swagger` for API documentation

# Architecture -

- 3 layer architecture (route, service, repository)
- Domain wise structure. Ex. Customer, Product (Vertical slicing)
- Typescript
- Business logic to be kept in service files
- Repository file for accessing database
- Validator files for request validators

# Commands -

- To build the project `npm run build`
- To run the project `npm run start`
- To run unit tests `npm run test`
- To see the test coverage `npm run test:cov`
